Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
24 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
25 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
26 7370f802 2022-07-24 op export GOT_IGNORE_GITCONFIG=1
27 96afb0d6 2023-01-21 stsp export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
28 c3754a5b 2019-05-10 stsp
29 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
30 7b67836a 2019-05-10 stsp
31 f6cae3ed 2020-09-13 naddy git_init()
32 0e673013 2019-01-02 stsp {
33 0b2899f8 2019-08-18 stsp git init -q "$1"
34 78caff98 2021-09-30 stsp
35 78caff98 2021-09-30 stsp # Switch the default branch to match our test expectations if needed.
36 78caff98 2021-09-30 stsp # Only need to change HEAD since 'git init' did not create any refs.
37 78caff98 2021-09-30 stsp # Relying on implementation details of 'git init' is no problem for us.
38 78caff98 2021-09-30 stsp # We want to be alerted when Git changes fundamental assumptions such
39 78caff98 2021-09-30 stsp # as what an empty repository looks like and where the default branch
40 78caff98 2021-09-30 stsp # is set. In such cases Got's own tooling might well need to change
41 78caff98 2021-09-30 stsp # its behaviour, too, and our tests should fail.
42 78caff98 2021-09-30 stsp # TODO: Update all tests to assume 'main' instead of 'master' and
43 78caff98 2021-09-30 stsp # switch to main here, to match Got's own default.
44 78caff98 2021-09-30 stsp echo "ref: refs/heads/master" > "$1/.git/HEAD"
45 0e673013 2019-01-02 stsp }
46 0e673013 2019-01-02 stsp
47 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
48 b32c4525 2020-01-05 stsp {
49 b32c4525 2020-01-05 stsp local repo="$1"
50 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
51 0a26275f 2022-01-03 stsp (cd $repo && gotadmin pack -a > /dev/null)
52 6fa5c67c 2022-01-03 stsp (cd $repo && gotadmin cleanup -a -q)
53 b32c4525 2020-01-05 stsp fi
54 b32c4525 2020-01-05 stsp }
55 b32c4525 2020-01-05 stsp
56 f6cae3ed 2020-09-13 naddy git_commit()
57 0e673013 2019-01-02 stsp {
58 0e673013 2019-01-02 stsp local repo="$1"
59 0e673013 2019-01-02 stsp shift
60 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
61 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
62 0e673013 2019-01-02 stsp }
63 0e673013 2019-01-02 stsp
64 f6cae3ed 2020-09-13 naddy git_rm()
65 512f0d0e 2019-01-02 stsp {
66 512f0d0e 2019-01-02 stsp local repo="$1"
67 512f0d0e 2019-01-02 stsp shift
68 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
69 512f0d0e 2019-01-02 stsp }
70 512f0d0e 2019-01-02 stsp
71 f6cae3ed 2020-09-13 naddy git_show_head()
72 9c4b8182 2019-01-02 stsp {
73 9c4b8182 2019-01-02 stsp local repo="$1"
74 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
75 9c4b8182 2019-01-02 stsp }
76 9c4b8182 2019-01-02 stsp
77 f6cae3ed 2020-09-13 naddy git_show_branch_head()
78 db32465d 2020-02-07 stsp {
79 db32465d 2020-02-07 stsp local repo="$1"
80 db32465d 2020-02-07 stsp local branch="$2"
81 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
82 db32465d 2020-02-07 stsp }
83 db32465d 2020-02-07 stsp
84 db32465d 2020-02-07 stsp
85 f6cae3ed 2020-09-13 naddy git_show_author_time()
86 bcb49d15 2019-08-14 stsp {
87 bcb49d15 2019-08-14 stsp local repo="$1"
88 01073a5d 2019-08-22 stsp local object="$2"
89 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
90 bcb49d15 2019-08-14 stsp }
91 bcb49d15 2019-08-14 stsp
92 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
93 8e7bd50a 2019-08-22 stsp {
94 8e7bd50a 2019-08-22 stsp local repo="$1"
95 8e7bd50a 2019-08-22 stsp local tag="$2"
96 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
97 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
98 8e7bd50a 2019-08-22 stsp }
99 8e7bd50a 2019-08-22 stsp
100 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
101 818c7501 2019-07-11 stsp {
102 818c7501 2019-07-11 stsp local repo="$1"
103 70551d57 2020-04-24 stsp local commit="$2"
104 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
105 818c7501 2019-07-11 stsp }
106 818c7501 2019-07-11 stsp
107 f6cae3ed 2020-09-13 naddy git_show_tree()
108 03415a1a 2019-06-02 stsp {
109 03415a1a 2019-06-02 stsp local repo="$1"
110 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
111 03415a1a 2019-06-02 stsp }
112 03415a1a 2019-06-02 stsp
113 f6cae3ed 2020-09-13 naddy trim_obj_id()
114 818c7501 2019-07-11 stsp {
115 9439a990 2020-09-16 naddy local trimcount=$1
116 9439a990 2020-09-16 naddy local id=$2
117 818c7501 2019-07-11 stsp
118 9439a990 2020-09-16 naddy local pat=""
119 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
120 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
121 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
122 818c7501 2019-07-11 stsp done
123 818c7501 2019-07-11 stsp
124 818c7501 2019-07-11 stsp echo ${id%$pat}
125 818c7501 2019-07-11 stsp }
126 818c7501 2019-07-11 stsp
127 f6cae3ed 2020-09-13 naddy git_commit_tree()
128 03415a1a 2019-06-02 stsp {
129 03415a1a 2019-06-02 stsp local repo="$1"
130 03415a1a 2019-06-02 stsp local msg="$2"
131 03415a1a 2019-06-02 stsp local tree="$3"
132 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
133 03415a1a 2019-06-02 stsp }
134 03415a1a 2019-06-02 stsp
135 f0fd0aaf 2021-09-14 stsp git_fsck()
136 f0fd0aaf 2021-09-14 stsp {
137 f0fd0aaf 2021-09-14 stsp local testroot="$1"
138 f0fd0aaf 2021-09-14 stsp local repo="$2"
139 f0fd0aaf 2021-09-14 stsp
140 f0fd0aaf 2021-09-14 stsp (cd $repo && git fsck --strict \
141 f0fd0aaf 2021-09-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
142 49c543a6 2022-03-31 naddy ret=$?
143 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
144 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
145 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
146 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
147 f0fd0aaf 2021-09-14 stsp return 1
148 f0fd0aaf 2021-09-14 stsp fi
149 f0fd0aaf 2021-09-14 stsp
150 f0fd0aaf 2021-09-14 stsp return 0
151 f0fd0aaf 2021-09-14 stsp }
152 f0fd0aaf 2021-09-14 stsp
153 f6cae3ed 2020-09-13 naddy make_test_tree()
154 0e673013 2019-01-02 stsp {
155 0e673013 2019-01-02 stsp repo="$1"
156 0e673013 2019-01-02 stsp
157 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
158 0e673013 2019-01-02 stsp echo beta > $repo/beta
159 0e673013 2019-01-02 stsp mkdir $repo/gamma
160 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
161 0e673013 2019-01-02 stsp mkdir $repo/epsilon
162 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
163 0e673013 2019-01-02 stsp }
164 0e673013 2019-01-02 stsp
165 f6cae3ed 2020-09-13 naddy make_single_file_repo()
166 e7303626 2020-05-14 stsp {
167 e7303626 2020-05-14 stsp repo="$1"
168 e7303626 2020-05-14 stsp file="$2"
169 e7303626 2020-05-14 stsp
170 e7303626 2020-05-14 stsp mkdir $repo
171 e7303626 2020-05-14 stsp git_init $repo
172 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
173 e7303626 2020-05-14 stsp (cd $repo && git add .)
174 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
175 e7303626 2020-05-14 stsp }
176 e7303626 2020-05-14 stsp
177 f6cae3ed 2020-09-13 naddy get_loose_object_path()
178 e7303626 2020-05-14 stsp {
179 e7303626 2020-05-14 stsp local repo="$1"
180 e7303626 2020-05-14 stsp local id="$2"
181 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
182 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
183 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
184 e7303626 2020-05-14 stsp }
185 e7303626 2020-05-14 stsp
186 f6cae3ed 2020-09-13 naddy get_blob_id()
187 3ce1b845 2019-07-15 stsp {
188 3ce1b845 2019-07-15 stsp repo="$1"
189 3ce1b845 2019-07-15 stsp tree_path="$2"
190 3ce1b845 2019-07-15 stsp filename="$3"
191 3ce1b845 2019-07-15 stsp
192 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
193 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
194 3ce1b845 2019-07-15 stsp }
195 3ce1b845 2019-07-15 stsp
196 f6cae3ed 2020-09-13 naddy test_init()
197 0e673013 2019-01-02 stsp {
198 0e673013 2019-01-02 stsp local testname="$1"
199 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
200 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
201 0e673013 2019-01-02 stsp echo "No test name provided" >&2
202 0e673013 2019-01-02 stsp return 1
203 0e673013 2019-01-02 stsp fi
204 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
205 0e673013 2019-01-02 stsp mkdir $testroot/repo
206 0e673013 2019-01-02 stsp git_init $testroot/repo
207 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
208 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
209 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
210 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
211 4a1ddfc2 2019-01-12 stsp fi
212 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
213 0e673013 2019-01-02 stsp echo "$testroot"
214 0e673013 2019-01-02 stsp }
215 0e673013 2019-01-02 stsp
216 f6cae3ed 2020-09-13 naddy test_cleanup()
217 0e673013 2019-01-02 stsp {
218 0e673013 2019-01-02 stsp local testroot="$1"
219 fe7842f5 2019-07-14 stsp
220 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
221 49c543a6 2022-03-31 naddy ret=$?
222 49c543a6 2022-03-31 naddy if [ $ret -ne 0 ]; then
223 f0fd0aaf 2021-09-14 stsp return $ret
224 fe7842f5 2019-07-14 stsp fi
225 fe7842f5 2019-07-14 stsp
226 0e673013 2019-01-02 stsp rm -rf "$testroot"
227 0e673013 2019-01-02 stsp }
228 0e673013 2019-01-02 stsp
229 f6cae3ed 2020-09-13 naddy test_parseargs()
230 7fb414ae 2020-08-08 stsp {
231 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
232 6c8da0c6 2020-10-03 naddy case $flag in
233 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
234 6c8da0c6 2020-10-03 naddy ;;
235 75b17c2a 2023-01-10 op r) export GOT_TEST_ROOT=${OPTARG%/}
236 6c8da0c6 2020-10-03 naddy ;;
237 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
238 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
239 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
240 6c8da0c6 2020-10-03 naddy exit 2
241 6c8da0c6 2020-10-03 naddy ;;
242 7fb414ae 2020-08-08 stsp esac
243 7fb414ae 2020-08-08 stsp done
244 6c8da0c6 2020-10-03 naddy } >&2
245 7fb414ae 2020-08-08 stsp
246 f6cae3ed 2020-09-13 naddy run_test()
247 0e673013 2019-01-02 stsp {
248 0e673013 2019-01-02 stsp testfunc="$1"
249 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
250 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
251 7fb414ae 2020-08-08 stsp fi
252 0e673013 2019-01-02 stsp $testfunc
253 0e673013 2019-01-02 stsp }
254 0e673013 2019-01-02 stsp
255 f6cae3ed 2020-09-13 naddy test_done()
256 0e673013 2019-01-02 stsp {
257 0e673013 2019-01-02 stsp local testroot="$1"
258 0e673013 2019-01-02 stsp local result="$2"
259 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
260 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
261 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
262 7fb414ae 2020-08-08 stsp echo "ok"
263 7fb414ae 2020-08-08 stsp fi
264 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
265 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
266 3941b73a 2019-05-14 stsp echo "$result"
267 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
268 0e673013 2019-01-02 stsp else
269 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
270 0e673013 2019-01-02 stsp fi
271 0e673013 2019-01-02 stsp }